package cn.com.tenlion.systembase.service.massprevention;

import cn.com.tenlion.systembase.pojo.bos.massprevention.MassPreventionBO;
import cn.com.tenlion.systembase.pojo.dtos.massprevention.MassPreventionDTO;
import cn.com.tenlion.systembase.pojo.pos.massprevention.MassPreventionPO;
import cn.com.tenlion.systembase.pojo.vos.massprevention.MassPreventionVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IMassPreventionService
 * @Description: 群防群治组织
 * @Author: CodeFactory
 * @Date: 2021-10-12 10:09:38
 * @Version: 3.0
 **/
public interface IMassPreventionService {

    /**
     * 新增群防群治组织
     *
     * @param massPreventionVO
     * @return
     */
    void save(MassPreventionVO massPreventionVO);

    /**
     * 新增群防群治组织
     *
     * @param token
     * @param massPreventionVO
     * @return
     */
    void save(String token, MassPreventionVO massPreventionVO);

    /**
     * 新增群防群治组织
     *
     * @param massPreventionVO
     * @return massPreventionId
     */
    String saveReturnId(MassPreventionVO massPreventionVO);

    /**
     * 新增群防群治组织
     *
     * @param token
     * @param massPreventionVO
     * @return massPreventionId
     */
    String saveReturnId(String token, MassPreventionVO massPreventionVO);

    /**
     * 删除群防群治组织
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除群防群治组织
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除群防群治组织（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改群防群治组织
     *
     * @param massPreventionId
     * @param massPreventionVO
     * @return
     */
    void update(String massPreventionId, MassPreventionVO massPreventionVO);

    /**
     * 修改群防群治组织
     *
     * @param token
     * @param massPreventionId
     * @param massPreventionVO
     * @return
     */
    void update(String token, String massPreventionId, MassPreventionVO massPreventionVO);

    /**
     * 群防群治组织详情
     *
     * @param params 参数Map
     * @return
     */
    MassPreventionDTO get(Map<String, Object> params);

    /**
     * 群防群治组织详情
     *
     * @param massPreventionId
     * @return
     */
    MassPreventionDTO get(String massPreventionId);

    /**
     * 群防群治组织详情
     *
     * @param params 参数Map
     * @return
     */
    MassPreventionBO getBO(Map<String, Object> params);

    /**
     * 群防群治组织详情
     *
     * @param massPreventionId
     * @return
     */
    MassPreventionBO getBO(String massPreventionId);

    /**
     * 群防群治组织详情
     *
     * @param params 参数Map
     * @return
     */
    MassPreventionPO getPO(Map<String, Object> params);

    /**
     * 群防群治组织详情
     *
     * @param massPreventionId
     * @return
     */
    MassPreventionPO getPO(String massPreventionId);

    /**
     * 群防群治组织列表
     *
     * @param params
     * @return
     */
    List<MassPreventionDTO> list(Map<String, Object> params);

    /**
     * 群防群治组织列表
     *
     * @param params
     * @return
     */
    List<MassPreventionBO> listBO(Map<String, Object> params);

    /**
     * 群防群治组织列表
     *
     * @param params
     * @return
     */
    List<MassPreventionPO> listPO(Map<String, Object> params);

    /**
     * 群防群治组织分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<MassPreventionDTO>> listPage(ListPage page);

    /**
     * 群防群治组织统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}